%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object           Location in Problem Statement                             Class
%matrix_tranche_benchmark    bench       matrix_tranche       meansquare_err(ltranche(matrix_tranche,vector_tparam))    double
%                                                             meanabs_pen(ltranche(matrix_tranche,vector_tparam))
%matrix_tranche_data         data        matrix_tranche       meansquare_err(ltranche(matrix_tranche,vector_tparam))    double
%                                                             meanabs_pen(ltranche(matrix_tranche,vector_tparam))
%matrix_tranche_vars         vars        matrix_tranche       meansquare_err(ltranche(matrix_tranche,vector_tparam))    cell
%                                                             meanabs_pen(ltranche(matrix_tranche,vector_tparam))
%vector_tparam_data          data        vector_tparam        meansquare_err(ltranche(matrix_tranche,vector_tparam))    double
%                                                             meanabs_pen(ltranche(matrix_tranche,vector_tparam))
%parameter_bound_data        data        parameter_bound      box: >=parameter_bound, <=parameter_bound_1               double
%parameter_bound_1_data      data        parameter_bound_1    box: >=parameter_bound, <=parameter_bound_1               double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_tranche_benchmark,matrix_tranche_data,matrix_tranche_vars,vector_tparam_data,parameter_bound_data,parameter_bound_1_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_tranche',matrix_tranche_data,matrix_tranche_vars,matrix_tranche_benchmark,[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_tparam',vector_tparam_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  meansquare_err(ltranche(matrix_tranche,vector_tparam))',...
'box: >=parameter_bound, <=parameter_bound_1',...
'value:',...
'  meanabs_pen(ltranche(matrix_tranche,vector_tparam))',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

